'TOOLKIT 27FEB98 PIC16C84 PROGRAMMING TOOLKIT - COPYRIGHT (c) JOHN BECKER
'MACHINE CODE COMPILED BY REGISTERED A86/D86 ASSEMBLER SOFTWARE

'*** WILL RUN UNDER QuickBASIC AND QBASIC                        ***
'*** QuickBASIC MUST BE LOADED WITH QB/L COMMAND (FROM DOS) FOR IT TO WORK **
'*** THE NORMAL QB COMMAND ON ITS OWN COULD RESULT IN A CRASH!   ***
'*** NOTE THAT SOME QuickBASICS MAY HAVE QB/L ALREADY IN THEIR .BAT FILE ***
'*** QBASIC DOES NOT NEED THE QB/L COMMAND ***

SCREEN 9: COLOR 15, 1: DIM a$(10), CODE$(255), reg$(63)
DIM decode$(1024), ma%(3150), ma, mb, mc, md: '1124
file$ = "toolkit.com": GOSUB setup: CLS : COLOR 15, 1
'file$ = "c:\a86\toolkit.com": GOSUB setup: CLS : COLOR 15, 1
LINE (2, 2)-(637, 347), 7, B: LINE (5, 5)-(634, 344), 7, B: PAINT (3, 3), 7, 7

portout% = &H378
'portout% = &H278
'portout% = &H3BC
'*** correct above portout% to &H278 or &H3BC or &H378 to suit the actual ***
'*** register used by your computer to access printer port LPT1        ***
'*** see EPE text and your computer manual - &H378 is the usual value  ***
OUT portout%, 0: ma%(18) = portout%: ma%(19) = portout% + 1

verify% = 1: ma%(17) = verify%
'*** to turn on VERIFY routine set verify% = 1, else set verify% = 0   ***
'*** VERIFY may not work for some computers using &H3BC/&H3BD          ***
'*** when VERIFY is off, disassembling from PIC is not possible        ***

menu: GOSUB clearit: COLOR 11, 1
LOCATE 4, 23: PRINT "EPE PIC16C84 PROGRAMMING TOOLKIT": COLOR 15, 1
LINE (154, 35)-(456, 63), 15, B: LINE (157, 38)-(453, 60), 15, B
PAINT (155, 36), 7, 15: LOCATE 7, 20: PRINT "1  CONFIGURE PIC16C84 FACTORS"

LOCATE 8, 20: PRINT "2  PROGRAM PIC16C84 WITH TASM BINARY FILE"
'dir$(2) = "C:\PIC\": dot$(2) = ".OBJ"
dir$(2) = "C:\PICTEST\": dot$(2) = ".OBJ"
smid$(2) = "xxx": dmid$(2) = "PIC16C84"

LOCATE 9, 20: PRINT "3  PROGRAM PIC16C84 WITH MPASM HEX FILE"
'dir$(3) = "C:\MPASMCNV\": dot$(3) = ".HEX"
dir$(3) = "C:\PICTEST\": dot$(3) = ".HEX"
smid$(3) = "xxx": dmid$(3) = "PIC16C84"

LOCATE 10, 20: PRINT "4  CONVERT MPASM HEX CODE TO TASM BINARY FILE"
'dir$(4) = "C:\MPASMCNV\": dot$(4) = ".HEX"
dir$(4) = "C:\PICTEST\": dot$(4) = ".HEX"
'destdir$(4) = "C:\PIC\": destdot$(4) = ".OBJ"
destdir$(4) = "C:\PICTEST\": destdot$(4) = ".OBJ"
smid$(4) = "xxx": dmid$(4) = "xxx"

LOCATE 11, 20: PRINT "5  CONVERT TASM BINARY FILE TO MPASM HEX CODE"
'dir$(5) = "C:\PIC\": dot$(5) = ".OBJ"
dir$(5) = "C:\PICTEST\": dot$(5) = ".OBJ"
smid$(5) = "xxx": dmid$(5) = "xxx"
'destdir$(5) = "C:\MPASMCNV\": destdot$(5) = ".HEX"
destdir$(5) = "C:\PICTEST\": destdot$(5) = ".HEX"
IF verify% = 0 THEN GOTO CONVERT8

LOCATE 12, 20: PRINT "6  DISASSEMBLE PIC16C84 TO TASM SOURCE CODE"
dir$(6) = "PIC16C84": dmid$(6) = "DECODE"
'destdir$(6) = "C:\PIC\": destdot$(6) = ".ASM"
destdir$(6) = "C:\PICTEST\": destdot$(6) = ".ASM"

LOCATE 13, 20: PRINT "7  DISASSEMBLE PIC16C84 TO MPASM SOURCE CODE"
dir$(7) = "PIC16C84": dmid$(7) = "DECODE"
'destdir$(7) = "C:\MPASMCNV\": destdot$(7) = ".ASM"
destdir$(7) = "C:\PICTEST\": destdot$(7) = ".ASM"

CONVERT8:
LOCATE 14, 20: PRINT "8  CONVERT TASM TEXT TO MPASM TEXT"
'dir$(8) = "C:\PIC\": dot$(8) = ".TSM": '".ASM"
dir$(8) = "C:\PICTEST\": dot$(8) = ".TSM": '".ASM"
smid$(8) = "xxx": dmid$(8) = "xxx"
'destdir$(8) = "C:\MPASMCNV\": destdot$(8) = ".ASM"
destdir$(8) = "C:\PICTEST\": destdot$(8) = ".ASM"

LOCATE 15, 20: PRINT "9  CONVERT MPASM TEXT TO TASM TEXT"
'dir$(9) = "C:\PIC\": dot$(9) = ".ASM"
dir$(9) = "C:\PICTEST\": dot$(9) = ".ASM"
smid$(9) = "xxx": dmid$(9) = "xxx"
'destdir$(9) = "C:\PIC\": destdot$(9) = ".TSM"
destdir$(9) = "C:\PICTEST\": destdot$(9) = ".TSM"

menu2:
LOCATE 16, 20: PRINT "P  SHOW DIRECTORY PATHS"
LOCATE 17, 20: PRINT "Q  QUIT FROM BASIC"
LOCATE 19, 20: PRINT "   ANY OTHER KEY STOPS PROGRAM": COLOR 11, 1
LOCATE 21, 20: PRINT "   WHICH SELECTION ?": GOSUB hold: COLOR 15, 1
z = VAL(z$): ON z GOTO 100, 200, 300, 400, 500, 600, 700, 800, 900
IF z$ = "P" OR z$ = "D" THEN GOTO 1000
IF z$ = "Q" THEN SYSTEM

STOP: GOTO menu

' ******************

100 : GOSUB clearit: LOCATE 2, 20: byte% = 0: ma%(0) = 0
PRINT "******* CONFIGURE PIC16C84 FACTORS *******"
LOCATE 4, 20: PRINT "1  LP LOW POWER CRYSTAL     32kHz - 200kHz"
LOCATE 5, 20: PRINT "2  XT MEDIUM SPEED CRYSTAL  100kHz - 4MHz"
LOCATE 6, 20: PRINT "3  HS HIGH SPEED CRYSTAL    4MHz - 10MHz"
LOCATE 7, 20: PRINT "4  RC RESISTOR-CAPACITOR OSCILLATOR"

LOCATE 9, 20: PRINT "WHICH OSCILLATOR TYPE ?"
hold3: GOSUB hold: z = VAL(z$): IF z > 4 THEN GOTO hold3
IF z = 0 THEN GOTO menu
byte% = z - 1: COLOR 14, 1: LOCATE 9, 46: PRINT osc$(z); " SELECTED"

COLOR 15, 1: LOCATE 10, 20: PRINT "ENABLE WATCHDOG TIME Y/N (DEFAULT NO)"
GOSUB hold: IF z$ = "Y" THEN wdt = 1: byte% = byte% OR 4 ELSE wdt = 0
COLOR 14, 1: LOCATE 10, 60: PRINT yes$(wdt)

COLOR 15, 1: LOCATE 11, 20: PRINT "ENABLE POWER-UP TIMER Y/N (DEFAULT YES)"
GOSUB hold: IF z$ = "N" THEN ptr = 0: byte% = byte% OR 8 ELSE ptr = 1
COLOR 14, 1: LOCATE 11, 60: PRINT yes$(ptr)

COLOR 15, 1: LOCATE 12, 20: PRINT "LOAD CONFIGURATION Y/N (DEFAULT YES)"
GOSUB hold: IF z$ <> "Y" AND z$ <> CHR$(13) THEN GOTO menu
COLOR 14, 1: LOCATE 12, 60: PRINT yes$(1): COLOR 15, 1
down = 14: GOSUB switchon: down = 16

ma%(5) = byte% OR 16: COLOR 14, 1
LOCATE down, 21: PRINT "SENDING CONFIGURATION TO PIC16C84": down = down + 2
GOSUB setmachinecodevariables: GOSUB sendcode

LOCATE down, 27: PRINT "FINISHED CONFIGURATION": COLOR 15, 1
down = down + 1: GOSUB switchoff: GOTO menu

' ********************

200 : s$ = "********* PROGRAM PIC16C84 FROM TASM BINARY CODE *********"
dr = 2: ma%(0) = 1
file2$ = "PIC16C84": GOSUB gettitle: IF file$ = "" THEN GOTO menu
IF RIGHT$(a$, 2) = CHR$(13) + CHR$(10) THEN a$ = LEFT$(a$, LEN(a$) - 2)
a$ = TASM$ + a$: b = LEN(a$) \ 2: COLOR 14, 1: LOCATE 7, 21
PRINT file$; " LOADED                  ": down = 8
c% = b / 1024 * 100: GOSUB sparebytes: IF b > 1024 THEN GOTO menu
ma%(11) = LEN(a$) \ 2: GOSUB programit: IF ok% = 0 THEN GOTO menu
IF verify% = 0 THEN GOTO 210
LOCATE 16, 20: COLOR 11, 1: PRINT ma%(16); "VERIFYING ERRORS FOUND"
IF ma%(16) > 1 THEN BEEP
210 : COLOR 14, 1: LOCATE 17, 21: PRINT "FINISHED SENDING "; file$
GOSUB switchoff: GOTO menu

' ********************

300 : s$ = "********* PROGRAM PIC16C84 FROM MPASM HEX CODE ********* "
dr = 3: ma%(0) = 5
file2$ = "PIC16C84": GOSUB gettitle: IF file$ = "" THEN GOTO menu
COLOR 14, 1: LOCATE 7, 21: PRINT file$; " LOADED              "
b = VAL("&h" + MID$(a$, 4, 4)): down = 8: FOR c = 1 TO LEN(a$)
IF MID$(a$, c, 1) = ":" THEN v = VAL("&h" + MID$(a$, c + 1, 2)): b = b + v
NEXT: b = b \ 2
c% = b / 1024 * 100: GOSUB sparebytes: IF b > 1024 THEN GOTO menu
ma%(11) = LEN(a$): GOSUB programit: IF ok% = 0 THEN GOTO menu
IF verify% = 0 THEN GOTO 310
LOCATE 17, 20: COLOR 11, 1: PRINT ma%(16); "VERIFYING ERRORS FOUND"
IF ma%(16) > 1 THEN BEEP
310 : COLOR 14, 1: LOCATE 18, 21: PRINT "FINISHED SENDING "; file$
GOSUB switchoff: GOTO menu

' ********************

400 : s$ = "    ********* CONVERT MPASM HEX CODE TO TASM BINARY FILE ********"
dr = 4: file2$ = destdir$(dr) + dmid$(dr) + destdot$(dr)
ma%(0) = 6: GOSUB gettitle: IF file$ = "" THEN GOTO menu
file2$ = destdir$(dr) + file3$ + destdot$(dr)
OPEN file2$ FOR OUTPUT AS #2: COLOR 14, 1: down = down + 1
COLOR 14, 1: LOCATE 7, 21: PRINT file$; " LOADED              "
b = VAL("&h" + MID$(a$, 4, 4)): down = 8: FOR c = 1 TO LEN(a$)
IF MID$(a$, c, 1) = ":" THEN v = VAL("&h" + MID$(a$, c + 1, 2)): b = b + v
NEXT: b = b \ 2: bb = b
c% = b / 1024 * 100: GOSUB sparebytes: IF b > 1024 THEN GOTO menu
ma%(11) = LEN(a$): GOSUB programit: IF ok% = 0 THEN GOTO menu
FOR a = 50 + 4 TO bb + 50 - 1: b = ma%(a): IF b < 0 THEN b = b + 65536
msb% = b \ 256: lsb% = b AND 255: lsb$ = CHR$(lsb%): msb$ = CHR$(msb%)
PRINT #2, lsb$; msb$; : NEXT: PRINT #2, "": CLOSE
COLOR 14, 1: LOCATE 17, 21: PRINT "FINISHED CONVERSION"
COLOR 15, 1: LOCATE 19, 21: PRINT "PRESS ANY KEY TO RETURN TO MENU"
GOSUB hold: GOTO menu

' ********************

500 : ma%(0) = 9: dr = 5: file2$ = destdir$(dr) + dmid$(dr) + destdot$(dr)
s$ = "    ********* CONVERT TASM BINARY FILE TO MPASM HEX CODE ********"
GOSUB gettitle: IF file$ = "" THEN GOTO menu
IF RIGHT$(a$, 2) = CHR$(13) + CHR$(10) THEN a$ = LEFT$(a$, LEN(a$) - 2)
COLOR 14, 1: LOCATE 7, 21: PRINT file$; " LOADED              "
file3$ = destdir$(dr) + file3$ + destdot$(dr)
OPEN file3$ FOR OUTPUT AS #2: COLOR 11, 1: LOCATE 9, 6
PRINT "CONVERTING TASM "; file$; " TO MPASM "; file3$: COLOR 15, 1
d = 8: e = 0: d$ = RIGHT$("000" + HEX$(d), 4): f$ = "00": c$ = "": 'd=10
n% = VAL("&h" + LEFT$(d$, 2)) + VAL("&h" + RIGHT$(d$, 2))

FOR c = 1 TO LEN(a$) STEP 2: e = e + 2: d = d + 2: 'c=3
b1% = ASC(MID$(a$, c, 1)): b2% = ASC(MID$(a$, c + 1, 1)): n% = n% + b1% + b2%
lsb$ = RIGHT$("0" + HEX$(b1%), 2): msb$ = RIGHT$("0" + HEX$(b2%), 2)
c$ = c$ + msb$ + lsb$: IF (d MOD 16) > 0 THEN GOTO 910
n% = n% + e: checksum = (-n%) AND 255: n$ = RIGHT$("0" + HEX$(checksum), 2)
e$ = RIGHT$("0" + HEX$(e), 2): c$ = ":" + e$ + d$ + f$ + c$ + n$
PRINT #2, c$: c$ = "": d$ = RIGHT$("000" + HEX$(d), 4)
n% = VAL("&h" + LEFT$(d$, 2)) + VAL("&h" + RIGHT$(d$, 2)): e = 0

910 : NEXT: IF (d MOD 16) = 0 THEN GOTO 920
n% = n% + e: checksum = (-n%) AND 255: n$ = RIGHT$("0" + HEX$(checksum), 2)
e$ = RIGHT$("0" + HEX$(e), 2): c$ = ":" + e$ + d$ + f$ + c$ + n$
PRINT #2, c$

920 : PRINT #2, ":00000001FF": CLOSE : LOCATE 11, 16: COLOR 14, 1
PRINT "FINISHED CONVERTING TASM BINARY TO MPASM HEX": COLOR 15, 1
LOCATE 13, 22: PRINT "PRESS ANY KEY TO RETURN TO MENU": GOSUB hold: GOTO menu

REM hex file coding example - :NNAAAARRMMLLMMLLMMLLMMLLCCTT
REM :    = record start character
REM NN   = byte quantity (H) in line as hex value
REM AAAA = address of first byte in hex
REM RR   = record type in hex (00 except for last record which is 01)
REM MMLL = data bytes in order of MMLL in hex
REM N.B.   MMLL = MSB/LSB FOR MPASM HEX, BUT LSB/MSB FOR TASM HEX
REM CC   = check sum in hex
REM TT   = line terminator (carriage return, line feed)
REM checksum defined as:
REM sum = byte count + address hi + address lo + record type + (sum of all data bytes)
REM checksum = (-sum) AND 255

'***************

600 : IF verify% = 0 THEN GOTO menu2
dr = 6: z = 1: type$ = " TASM ": hex1$ = "$": hex2$ = "": hex4$ = "."
GOTO 602
700 : IF verify% = 0 THEN GOTO menu2
dr = 7: z = 2: type$ = " MPASM ": hex1$ = "H'": hex2$ = "'": hex4$ = ""

602 : GOSUB clearit: down = 2: unfound = 0
file$ = destdir$(dr) + dmid$(dr) + destdot$(dr)
s$ = "******** DISASSEMBLE FROM PIC16C84 TO" + type$ + "SOURCE CODE ********"
GOSUB lines: COLOR 14, 1: LOCATE 3, 21: PRINT "OUTPUT IS TO "; file$
LOCATE 10, 21: PRINT "DO YOU WISH TO PROCESS THIS PROGAM Y/N ?"
GOSUB hold: IF z$ <> "Y" AND z$ <> CHR$(13) THEN GOTO menu
GOSUB switchon: COLOR 14, 1
LOCATE 15, 21: PRINT "DISASSEMBLING PIC16C84 TO"; type$
COLOR 15, 1: GOSUB setmachinecodevariables
ma%(0) = 2: FOR count = 0 TO 1023: GOSUB sendcode: byte% = ma%(5): ma%(0) = 3
GOSUB decode: NEXT: COLOR 14, 1: LOCATE 16, 21: PRINT "OUTPUT TO FILE "; file$
OPEN file$ FOR OUTPUT AS #1
PRINT #1, "; DISASSEMBLY FROM PIC16C84 TO"; type$; "ON "; DATE$; " AT "; TIME$
PRINT #1, "": IF z = 1 THEN PRINT #1, "       .AVSYM"
IF z = 2 THEN PRINT #1, "       LIST P=16C84,R=DEC": PRINT #1, ""
FOR a = 0 TO 11: a$ = LEFT$(reg$(a) + ":         ", 10)
a$ = a$ + hex4$ + "EQU " + hex1$ + RIGHT$("0" + HEX$(a), 2) + hex2$
PRINT #1, a$: NEXT:
IF z = 1 THEN PRINT #1, "W:        .EQU 0": PRINT #1, "F:        .EQU 1"
IF z = 2 THEN PRINT #1, "W:        EQU 0": PRINT #1, "F:        EQU 1"
PRINT #1, ""
IF z = 1 THEN PRINT #1, "          .ORG 4"
IF z = 2 THEN PRINT #1, "          ORG 4"
PRINT #1, decode$(4)
IF z = 1 THEN PRINT #1, "          .ORG 5"
IF z = 2 THEN PRINT #1, "          ORG 5"
FOR count = 0 TO 4: decode$(count) = "": NEXT
FOR count = 5 TO 1023: IF LEFT$(decode$(count), 3) <> "   " THEN PRINT #1, ""
PRINT #1, decode$(count): decode$(count) = "": NEXT
IF z = 1 THEN PRINT #1, "          .END"
IF z = 2 THEN PRINT #1, "          END"
CLOSE : LOCATE 17, 20: COLOR 11, 1
IF unfound > 0 THEN PRINT unfound; "CODES NOT FOUND - EXAMINE DECODE FILE"
COLOR 14, 1: LOCATE 18, 21: PRINT "FINISHED DISASSEMBLING PIC16C84 TO"; type$
GOSUB switchoff: GOTO menu

decode: byte% = byte% \ 2: msb% = byte% \ 128: code2$ = ""
jd = byte%: FOR jt = 14 TO 0 STEP -1: ja = 2 ^ jt: jw = jd / ja
IF jw >= 1 THEN jd = jd - ja: code2$ = code2$ + "1" ELSE code2$ = code2$ + "0"
NEXT

reg$ = "": lsb$ = "": IF msb% = 0 THEN msb% = (byte% AND 15) + 128
IF msb% > 63 THEN GOTO d1
lsb% = byte% AND 127: lsb$ = ""
IF lsb% > 11 AND lsb% < 64 THEN lsb$ = hex1$ + reg$(lsb%) + hex2$
IF lsb% < 12 THEN lsb$ = reg$(lsb%)
IF lsb% > 63 THEN lsb$ = STR$(lsb%)
lsb$ = lsb$ + RIGHT$(CODE$(msb%), 2): GOTO d10

d1:
IF msb% < 80 THEN msb% = 64: lsb% = byte% AND 1023: lsb$ = STR$(lsb%): GOTO d10
IF msb% < 96 THEN msb% = 80: lsb% = byte% AND 1023: lsb$ = STR$(lsb%): GOTO d10
IF msb% < 104 THEN msb% = 96: GOTO d5
IF msb% < 112 THEN msb% = 104: GOTO d5
IF msb% < 114 THEN msb% = 112: GOTO d5
IF msb% < 116 THEN msb% = 114: GOTO d5
IF msb% < 120 THEN msb% = 116: GOTO d5
IF msb% < 124 THEN msb% = 120: GOTO d5
IF msb% < 128 THEN msb% = 124

d5: IF msb% > 80 THEN lsb% = byte% AND 255: lsb$ = STR$(lsb%) + RIGHT$(CODE$(msb%), 2): GOTO d10
msb% = msb% AND 126: lsb% = byte% AND 2047: lsb$ = STR$(lsb%) + RIGHT$(CODE$(msb%), 2)

d10: lsb$ = LTRIM$(lsb$): IF msb% <> 80 AND msb% <> 64 THEN GOTO d12
lsb$ = "JMP" + lsb$: label$ = LEFT$(lsb$ + ":        ", 10)

IF lsb% >= count THEN decode$(lsb%) = label$: GOTO d13
IF LEFT$(decode$(lsb%), 7) = "       " THEN decode$(lsb%) = label$ + MID$(decode$(lsb%), 11): GOTO d13
d12: IF msb% > 127 THEN lsb$ = ""
d13: IF CODE$(msb%) <> "" THEN GOTO d14
decode$(count) = decode$(count) + "   ; UNFOUND " + MID$(code2$, 2, 14)
unfound = unfound + 1: RETURN

d14: msb$ = LEFT$(CODE$(msb%), 7)
IF decode$(count) = "" THEN decode$(count) = "          "
decode$(count) = decode$(count) + msb$ + lsb$
IF msb% < 96 OR msb% > 124 THEN RETURN
msb$ = "; %" + MID$(code2$, 8, 8) + " $": lsb$ = RIGHT$("0" + HEX$(lsb%), 2)
IF msb% <> 96 AND msb% <> 104 THEN RETURN
IF lsb% > 13 THEN lsb$ = lsb$ + " " + CHR$(34) + CHR$(lsb%) + CHR$(34)
decode$(count) = LEFT$(decode$(count) + sp2$, 28) + msb$ + lsb$: RETURN

' ********************

800 : s$ = "******** CONVERT TASM SOURCE TEXT TO MPASM SOURCE TEXT ********"
dr = 8: ma%(0) = 7: file2$ = "FILE " + destdir$(dr) + dmid$(dr) + destdot$(dr)
GOSUB gettitle: IF file$ = "" THEN GOTO menu
COLOR 14, 1: LOCATE 7, 21: PRINT file$; " LOADED                  "
file3$ = destdir$(dr) + file3$ + destdot$(dr)
OPEN file3$ FOR OUTPUT AS #2: COLOR 11, 1
LOCATE 9, 6: PRINT "CONVERTING TASM "; file$; " TO MPASM "; file3$
PRINT #2, "; CONVERTED TASM "; file$; " TO MPASM "; file3$; " "; DATE$; " "; TIME$
COLOR 15, 1: PRINT #2, "": PRINT #2, "        "; "list p=16c84,r=dec"

FOR c = 1 TO LEN(a$): c$ = MID$(a$, c, 1)
IF c$ = CHR$(10) OR c$ = CHR$(20) THEN GOTO 720
IF c$ = CHR$(13) THEN GOSUB checkit: GOTO 720
IF c$ = " " AND b$ = " " THEN GOTO 720
IF c$ = ";" THEN colon = 1: d = 4
IF colon = 1 THEN GOTO 710
IF c$ = " " AND b$ <> "'" THEN d = d + 1: GOTO 720
IF c$ = "," THEN d = d + 1
710 : a$(d) = a$(d) + c$
720 : b$ = c$: NEXT: GOSUB checkit: COLOR 14, 1

CLOSE : LOCATE 11, 21: PRINT "FINISHED TASM TO MPASM CONVERSION"
COLOR 15, 1: LOCATE 13, 22: PRINT "PRESS ANY KEY TO RETURN TO MENU"
GOSUB hold: GOTO menu

checkit: IF a$(0) = "OPTION:" THEN a$(0) = "OPSHUN:"
IF a$(2) = "OPTION" THEN a$(2) = "OPSHUN"
IF RIGHT$(a$(0), 1) = ":" THEN a$(0) = LEFT$(a$(0), LEN(a$(0)) - 1)
a$(0) = UCASE$(LEFT$(a$(0) + "         ", 8))
IF LEFT$(a$(1), 1) = "." THEN a$(1) = MID$(a$(1), 2)
IF LEFT$(a$(2), 1) = "%" THEN a$(2) = "B'" + MID$(a$(2), 2) + "'"
IF LEFT$(a$(2), 1) = "$" THEN a$(2) = "H'" + MID$(a$(2), 2) + "'"
IF a$(1) = "AVSYM" THEN a$(1) = ";" + a$(1)
a$(1) = UCASE$(a$(1) + " " + a$(2))
IF LEFT$(a$(0), 1) = "#" THEN a$(1) = a$(1) + " ": GOSUB correcthex
IF LEFT$(a$(3), 1) = "," THEN a$(1) = a$(1) + a$(3): a$(3) = ""
IF LEFT$(a$(0), 1) <> "#" THEN a$(1) = LEFT$(a$(1) + "                  ", 18)
b$ = a$(0) + a$(1) + a$(3) + a$(4): PRINT #2, b$: FOR a = 0 TO 5: a$(a) = ""
NEXT: b$ = "": d = 0: colon = 0: RETURN

correcthex: IF LEFT$(a$(3), 1) <> "$" THEN RETURN
a$(3) = "H'" + MID$(a$(3), 2, 2) + "'" + MID$(a$(3), 4): RETURN

' ******************

900 : s$ = "********* CONVERT MPASM SOURCE TEXT TO TASM SOURCE TEXT *********"
dr = 9: ma%(0) = 8: file2$ = "FILE " + destdir$(dr) + dmid$(dr) + destdot$(dr)
GOSUB gettitle: IF file$ = "" THEN GOTO menu
COLOR 14, 1: LOCATE 7, 21: PRINT file$; " LOADED                  "
file2$ = "FILE " + file$
file3$ = destdir$(dr) + file3$ + destdot$(dr): OPEN file3$ FOR OUTPUT AS #2
COLOR 11, 1
LOCATE 9, 10: PRINT "CONVERTING MPASM "; file$; " TO TASM "; file3$

PRINT #2, ";CONVERTED MPASM "; file2$
PRINT #2, ";       TO TASM  FILE "; file3$; " "; DATE$; " "; TIME$
PRINT #2, "": radix$ = "HEX"

e = 1: FOR c = 1 TO LEN(a$): IF MID$(a$, c, 1) <> CHR$(10) THEN GOTO loop1
b$ = MID$(a$, e, c - e): e = c + 1: IF b$ = "" THEN GOTO printit
FOR d = 1 TO 4: d$(d) = "": NEXT

trimexcess:
FOR d = LEN(b$) TO 1 STEP -1: IF MID$(b$, d, 1) > " " THEN EXIT FOR
NEXT: b$ = LEFT$(b$, d): IF b$ = "" THEN GOTO printit

getcomments:
d$ = "": x$ = "": FOR d = 1 TO LEN(b$): e$ = MID$(b$, d, 1)
IF e$ = ";" THEN d$ = MID$(b$, d): b$ = LEFT$(b$, d - 1): EXIT FOR
NEXT: IF b$ <> "" THEN x$ = "; * " + b$

splitsections: b$ = UCASE$(b$): c$ = "": g = 0: f = 1
FOR d = 1 TO LEN(b$): e$ = MID$(b$, d, 1): IF e$ = CHR$(9) THEN e$ = " "
IF e$ = " " AND c$ = " " THEN f = d + 1: GOTO 810
IF e$ = " " THEN g = g + 1: d$(g) = MID$(b$, f, d - f): f = d + 1
810 : c$ = e$: NEXT: g = g + 1: d$(g) = MID$(b$, f, d - f)

cblockcheck: IF cblock = 1 THEN GOTO cblocksplit
db = 0: FOR d = 1 TO g: IF LEFT$(d$(d), 6) = "CBLOCK" THEN db = d: EXIT FOR
NEXT: IF db = 0 THEN GOTO correctequ
cblock = 1: h$ = "&h" + MID$(d$(db + 1), 3): h = VAL(h$): PRINT , d$(db), h$; h: GOTO loop1

cblocksplit: IF LEFT$(d$(db), 4) = "ENDC" THEN cblock = 0: GOTO loop1
IF cblock = 0 THEN GOTO correctequ
IF d$(db) = "" THEN GOTO loop1
cb$ = d$(db) + ","
ee = 1: FOR cc = 1 TO LEN(cb$): IF MID$(cb$, cc, 1) <> "," THEN GOTO loopit2
c$ = HEX$(h): IF h < 16 THEN c$ = "0" + c$
dd$ = LEFT$(MID$(cb$, ee, cc - ee) + ":        ", 8) + " .EQU $" + c$
PRINT #2, dd$: h = h + 1: ee = cc + 1
loopit2: NEXT: GOTO loop1

correctequ: IF g = 0 THEN GOTO loop1
FOR d = 1 TO g

IF d$(d) = "#DEFINE" THEN GOSUB expanddefine: EXIT FOR

IF d$(d) = "TITLE" THEN d$(d) = "; TITLE": EXIT FOR
IF d$(d) = "MOVFW" THEN GOSUB expandmovfw: EXIT FOR
IF d$(d) = "NEGF" THEN GOSUB expandnegf: EXIT FOR
IF d$(d) = "SUBCF" THEN GOSUB expandsubcf: EXIT FOR
IF d$(d) = "SUBDCF" THEN GOSUB expandsubdcf: EXIT FOR
IF d$(d) = "TSTF" THEN GOSUB expandtstf: EXIT FOR

IF d$(d) = "CLRC" THEN GOSUB expandclrf: EXIT FOR
IF d$(d) = "CLRDC" THEN GOSUB expandclrdc: EXIT FOR
IF d$(d) = "CLRZ" THEN GOSUB expandclrz: EXIT FOR
IF d$(d) = "SETC" THEN GOSUB expandsetc: EXIT FOR
IF d$(d) = "SETDC" THEN GOSUB expandsetdc: EXIT FOR
IF d$(d) = "SETZ" THEN GOSUB expandsetz: EXIT FOR
IF d$(d) = "SKPC" THEN GOSUB expandskpc: EXIT FOR
IF d$(d) = "SKPDC" THEN GOSUB expandskpdc: EXIT FOR
IF d$(d) = "SKPZ" THEN GOSUB expandskpz: EXIT FOR

IF d$(d) = "ADDCF" THEN GOSUB expandaddcf: EXIT FOR
IF d$(d) = "ADDDCF" THEN GOSUB expandadddcf: EXIT FOR
IF d$(d) = "B" THEN GOSUB expandb: EXIT FOR
IF d$(d) = "BC" THEN GOSUB expandbc: EXIT FOR
IF d$(d) = "BDC" THEN GOSUB expandbdc: EXIT FOR
IF d$(d) = "BNC" THEN GOSUB expandbnc: EXIT FOR
IF d$(d) = "BNDC" THEN GOSUB expandbndc: EXIT FOR
IF d$(d) = "BZ" THEN GOSUB expandbz: EXIT FOR

IF d$(d) = "EQU" THEN GOSUB pointit: EXIT FOR
IF d$(d) = "ORG" THEN GOSUB pointit: d$(d + 2) = d$(d + 2) + "; CHECK ORG!": EXIT FOR
IF d$(d) = "END" THEN d$(d) = "": EXIT FOR
IF d$(d) = "SET" THEN d$(d) = "EQU": GOSUB pointit: EXIT FOR

IF RIGHT$(d$(d), 2) = "LW" THEN GOSUB getvalue: EXIT FOR
IF LEFT$(d$(d), 4) <> "LIST" THEN GOTO 820
d$(2) = ";": d$(1) = "": d$(3) = "": d$(4) = b$: FOR dd = 1 TO LEN(b$)
IF MID$(b$, dd, 2) = "R=" THEN radix$ = MID$(b$, dd): EXIT FOR
NEXT: EXIT FOR
820 : NEXT
IF LEFT$(d$(1), 1) = "#" THEN GOTO 830
IF RIGHT$(d$(1), 1) <> ":" AND d$(1) <> "" THEN d$(1) = d$(1) + ": "
830 :
IF LEN(d$(1)) > 12 THEN d$(1) = LEFT$(d$(1) + sp$, 16): GOTO addcodes
IF LEN(d$(1)) > 9 THEN d$(1) = LEFT$(d$(1) + sp$, 12): GOTO addcodes
IF LEN(d$(1)) < 9 THEN d$(1) = LEFT$(d$(1) + sp$, 8)
addcodes: b$ = d$(1) + d$(2) + " " + d$(3) + " " + d$(4)
IF LEN(b$) < 30 THEN b$ = LEFT$(b$ + sp2$, 30) ELSE b$ = b$ + " "
b$ = b$ + d$

printit: PRINT #2, b$
IF expand$ <> "" THEN PRINT #2, sp$; expand$: PRINT #2, "": expand$ = ""

loop1: NEXT c: PRINT #2, sp$; ".END": CLOSE : COLOR 14, 1: LOCATE 11, 21
PRINT "FINISHED MPASM TO TASM CONVERSION": COLOR 15, 1: LOCATE 13, 22
PRINT "PRESS ANY KEY TO RETURN TO MENU": GOSUB hold: GOTO menu

pointit: d$(d) = "." + d$(d)
point2: IF d = 2 THEN GOTO getvalue
FOR a = 1 TO g: d$(a) = d$(a + 1): NEXT: d = d - 1: GOTO point2

getvalue:
IF LEFT$(d$(d + 1), 1) = "." THEN d$(d + 1) = MID$(d$(d + 1), 2): RETURN
IF LEFT$(d$(d + 1), 1) = "%" THEN RETURN
IF VAL(d$(d + 1)) > 0 THEN GOTO radixcheck
IF d$(d + 1) = "0" THEN RETURN
IF LEFT$(d$(d + 1), 1) = "0" THEN GOTO hexit
IF LEFT$(d$(d + 1), 2) = "B'" THEN GOTO binit
IF LEFT$(d$(d + 1), 2) = "D'" THEN GOTO decimal
IF LEFT$(d$(d + 1), 2) = "H'" THEN GOTO hexit2
RETURN

radixcheck: IF radix$ = "R=DEC" THEN RETURN: REM defaults to hexit
hexit: d$(d + 1) = "$" + RIGHT$("0" + d$(d + 1), 2): RETURN
binit: d$(d + 1) = "%" + MID$(d$(d + 1), 3, 8): RETURN
decimal: d$(d + 1) = MID$(d$(d + 1), 3)
d$(d + 1) = LEFT$(d$(d + 1), LEN(d$(d + 1)) - 1): RETURN
hexit2: d$(d + 1) = "$" + MID$(d$(d + 1), 3)
d$(d + 1) = LEFT$(d$(d + 1), LEN(d$(d + 1)) - 1): RETURN

expandmovfw: d$(d) = "MOVF": d$(d + 1) = d$(d + 1) + ",W" + sp$ + "  ; ###" + b$: RETURN

expandsubcf: d$(d) = "BTFSC"
expand$ = "DECF " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,C": d$(d + 2) = "  ; ###" + b$: RETURN

expandsubdcf: d$(d) = "BTFSC"
expand$ = "DECF " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,DC": d$(d + 2) = "  ; ###" + b$: RETURN

expandaddcf: d$(d) = "BTFSC"
expand$ = "INCF " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,C": d$(d + 2) = "  ; ###" + b$: RETURN

expandadddcf: d$(d) = "BTFSC"
expand$ = "INCF " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,DC": d$(d + 2) = "  ; ###" + b$: RETURN

expandbc: d$(d) = "BTFSC"
expand$ = "GOTO " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,C": d$(d + 2) = "  ; ###" + b$: RETURN

expandbdc: d$(d) = "BTFSC"
expand$ = "GOTO " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,DC": d$(d + 2) = "  ; ###" + b$: RETURN

expandbnc: d$(d) = "BTFSS"
expand$ = "GOTO " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,C": d$(d + 2) = "  ; ###" + b$: RETURN

expandbndc: d$(d) = "BTFSS"
expand$ = "GOTO " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,DC": d$(d + 2) = "  ; ###" + b$: RETURN

expandbz: d$(d) = "BTFSC"
expand$ = "GOTO " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = "STATUS,Z": d$(d + 2) = "  ; ###" + b$: RETURN

expandb: d$(d) = "GOTO " + d$(d + 1) + sp$ + "  ; ###" + b$
d$(d + 1) = "": RETURN

expandnegf: d$(d) = "COMF"
expand$ = "INCF " + d$(d + 1) + d$(d + 2) + "  ; ###"
d$(d + 1) = LEFT$(d$(d + 1), LEN(d$(d + 1)) - 1) + "F"
d$(d + 2) = "  ; ###" + b$: RETURN

expandtstf: d$(d) = "MOVF": d$(d + 1) = d$(d + 1) + ",F" + "  ; ###" + b$: RETURN

expandclrf: d$(d) = "BCF": d$(d + 1) = "STATUS,C" + "  ; ###" + b$: RETURN
expandclrdc: d$(d) = "BCF": d$(d + 1) = "STATUS,DC" + "  ; ###" + b$: RETURN
expandclrz: d$(d) = "BCF": d$(d + 1) = "STATUS,Z" + "  ; ###" + b$: RETURN
expandsetc: d$(d) = "BSF": d$(d + 1) = "STATUS,C" + "  ; ###" + b$: RETURN
expandsetdc: d$(d) = "BSF": d$(d + 1) = "STATUS,DC" + "  ; ###" + b$: RETURN
expandsetz: d$(d) = "BSF": d$(d + 1) = "STATUS,Z" + "  ; ###" + b$: RETURN
expandskpc: d$(d) = "BTFSS": d$(d + 1) = "STATUS,C" + "  ; ###" + b$: RETURN
expandskpdc: d$(d) = "BTFSS": d$(d + 1) = "STATUS,DC" + "  ; ###" + b$: RETURN
expandskpz: d$(d) = "BTFSS": d$(d + 1) = "STATUS,Z" + "  ; ###" + b$: RETURN

expanddefine: FOR ddj = d TO g: IF LEFT$(d$(ddj), 2) <> "H'" THEN GOTO loopdefine
ddk$ = "&H" + MID$(d$(ddj), 3): ddk = VAL(ddk$)
FOR ddm = 3 TO LEN(d$(ddj)): IF MID$(d$(ddj), ddm, 1) = "'" THEN EXIT FOR
NEXT: d$(ddj) = STR$(ddk) + MID$(d$(ddj), ddm + 1): EXIT FOR
loopdefine: NEXT: RETURN

' ******************

1000 : down = 2: GOSUB clearit
s$ = "********* SHOW DIRECTORY PATHS *********": GOSUB lines
LOCATE 6, 3: PRINT "FUNCTION"; TAB(39); : PRINT "SOURCE"
LOCATE 6, 57: PRINT "DESTINATION"
LOCATE 8, 3: PRINT "2 PROGRAM PIC16C84 WITH TASM BINARY"
LOCATE 9, 3: PRINT "3 PROGRAM PIC16C84 WITH MPASM HEX"
LOCATE 10, 3: PRINT "4 CONVERT MPASM HEX TO TASM BINARY"
LOCATE 11, 3: PRINT "5 CONVERT TASM BINARY TO MPASM HEX"
LOCATE 12, 3: PRINT "6 DISASSEMBLE PIC TO TASM SOURCE"
LOCATE 13, 3: PRINT "7 DISASSEMBLE PIC TO MPASM SOURCE"
LOCATE 14, 3: PRINT "8 CONVERT TASM TEXT TO MPASM TEXT"
LOCATE 15, 3: PRINT "9 CONVERT MPASM TEXT TO TASM TEXT"
LOCATE 17, 20: PRINT "OUTPUT TO PRINTER PORT VIA REGISTER 0"; HEX$(portout%); "h"

FOR a = 2 TO 9: LOCATE 6 + a, 39: PRINT dir$(a); smid$(a); dot$(a)
LOCATE 6 + a, 57: PRINT destdir$(a); dmid$(a); destdot$(a): NEXT
COLOR 11, 1: LOCATE a + 9, 25: PRINT "PRESS ANY KEY TO RETURN TO MENU"
GOSUB hold: COLOR 15, 1: GOTO menu

'***************

hold: z$ = UCASE$(INKEY$): IF z$ = "" THEN GOTO hold
IF z$ = "Z" THEN STOP
RETURN

' ********************

fault: CLOSE : LOCATE 10, 17: BEEP
PRINT "THIS FILE IS"; b - 32767; "BYTES TOO LONG TO PROCESS": LOCATE 12, 4
PRINT "IT IS SUGGESTED YOU DELETE SOME OF ITS COMMENTS AND THEN TRY AGAIN"
COLOR 15, 1: LOCATE 14, 21
PRINT "PRESS ANY KEY TO RETURN TO MENU": GOSUB hold: RETURN

gettitle: down = 2: GOSUB clearit: GOSUB lines: COLOR 14, 1
LOCATE 3, 21
PRINT "SOURCE FILE SEARCHED IS "; dir$(dr); smid$(dr); dot$(dr)
COLOR 15, 1: LOCATE 4, 21: PRINT "OUTPUT IS TO "; file2$
IF ma%(0) > 5 THEN GOTO GT2
IF verify% = 1 THEN LOCATE 5, 21: COLOR 11, 1: PRINT "VERIFYING IS AUTOMATIC"
GT2: COLOR 15, 1: GOSUB getfilename: IF file$ = "" THEN RETURN
file3$ = file$
file$ = dir$(dr) + file$ + dot$(dr): COLOR 11, 1: f$ = "FILE NOT FOUND " + file$
OPEN file$ FOR BINARY AS #1: b = LOF(1)
IF b = 0 THEN LOCATE 7, 21: CLOSE : PRINT f$: KILL file$: BEEP: GOTO GT2
IF b < 32767 THEN a$ = INPUT$(b, 1): CLOSE : COLOR 15, 1: RETURN
GOSUB fault: GOTO menu

getfilename: LOCATE 6, 21: COLOR 15, 1
PRINT "PROCESS WHICH FILE                   "
LOCATE 6, 40: INPUT file$: file$ = UCASE$(file$)
FOR c = 1 TO LEN(file$)
IF MID$(file$, c, 1) = "." THEN file$ = LEFT$(file$, c - 1): EXIT FOR
NEXT: LOCATE 6, 42: COLOR 11, 1: PRINT file$; "    ": RETURN

switchon: COLOR 15, 1: LOCATE 13, 5: PRINT "FOR PICTUTOR PCB SET ";
PRINT "S2, S1, S3, S4 ON, THEN S2 OFF AND PRESS ANY KEY"
LOCATE 14, 21: PRINT "FOR TOOLKIT PCB JUST PRESS ANY KEY"
OUT portout%, 8 OR 16: REM reset on, 12V on
GOSUB hold: OUT portout%, 16: RETURN: REM reset off, 12V on

switchoff: COLOR 15, 1: LOCATE 19, 11
PRINT "FOR PICTUTOR PCB SET S2 ON, S1, S3, S4 OFF, THEN S2 OFF"
OUT portout%, 8: OUT portout%, 0: REM reset on then off, 12V off
LOCATE 20, 21: PRINT "FOR TOOLKIT PCB JUST PRESS ANY KEY"
LOCATE 21, 24: PRINT "ANY KEY PRESS RESTORES MENU": GOSUB hold: RETURN

programit: ok% = 0: COLOR 15, 1
LOCATE 10, 21: PRINT "DO YOU WISH TO PROCESS THIS PROGAM Y/N ?"
GOSUB hold: IF z$ <> "Y" AND z$ <> CHR$(13) THEN RETURN
ok% = 1: ma%(10) = VARSEG(a$): b = VARPTR(a$): a = 256
g = PEEK(b + 3) * a + PEEK(b + 2): IF g > 32767! THEN g = g - 65536!
ma%(13) = g: IF ma%(0) < 6 THEN GOSUB switchon
LOCATE 15, 21: COLOR 14, 1: PRINT "SENDING "; file$; " TO "; file2$
GOSUB setmachinecodevariables: GOSUB sendcode: RETURN

sparebytes: b$ = STR$(b) + " BYTES = " + MID$(STR$(c%), 2) + "% OF PIC WITH"
IF 1024 - b < 0 THEN b$ = b$ + " "
LOCATE down, 20: b$ = b$ + STR$(1024 - b) + " SPARE BYTES": PRINT b$
IF b < 1025 THEN RETURN
COLOR 11, 1: LOCATE down + 1, 21: BEEP
PRINT "PROGRAM TOO LONG BY"; b - 1024; "BYTES": COLOR 15, 1
LOCATE down + 2, 21: PRINT "PRESS ANY KEY TO RETURN TO MENU"
GOSUB hold: RETURN

' ********************

DATA "003clrf     ","002clrw     ": '0000011fffffff,00000100000011
DATA "132clrwdt   ","137retfie   ": '00000001100100,00000000001001
DATA "136return   ","131sleep    ": '00000000001000,00000001100011
DATA "128nop      ":                '0000000xx00000

DATA "014addwf  ,W","015addwf  ,F": '0001110fffffff,,0001111fffffff
DATA "010andwf  ,W","011andwf  ,F": '0001010fffffff,0001011fffffff
DATA "018comf   ,W","019comf   ,F": '0010010fffffff,0010011fffffff
DATA "006decf   ,W","007decf   ,F": '0000110fffffff,0000111fffffff
DATA "022decfsz ,W","023decfsz ,F": '0010110fffffff,0010111fffffff
DATA "020incf   ,W","021incf   ,F": '0010100fffffff,0010101fffffff
DATA "030incfsz ,W","031incfsz ,F": '0011110fffffff,0011111fffffff
DATA "008iorwf  ,W","009iorwf  ,F": '0001000fffffff,0001001fffffff
DATA "016movf   ,W","017movf   ,F": '0010000fffffff,0010001fffffff
DATA "001movwf    ":                '0000001fffffff
DATA "026rlf    ,W","027rlf    ,F": '0011010fffffff,0011011fffffff
DATA "024rrf    ,W","025rrf    ,F": '0011000fffffff,0011001fffffff
DATA "004subwf  ,W","005subwf  ,F": '0000100fffffff,0000101fffffff
DATA "028swapf  ,W","029swapf  ,F": '0011100fffffff,0011101fffffff
DATA "012xorwf  ,W","013xorwf  ,F": '0001100fffffff,0001101fffffff

DATA " 32bcf    ,0"," 33bcf    ,1": '0100000fffffff,0100001fffffff
DATA " 34bcf    ,2"," 35bcf    ,3": '0100010fffffff,0100011fffffff
DATA " 36bcf    ,4"," 37bcf    ,5": '0100100fffffff,0100101fffffff
DATA " 38bcf    ,6"," 39bcf    ,7": '0100110fffffff,0100111fffffff

DATA " 40bsf    ,0"," 41bsf    ,1": '0101000fffffff,0101001fffffff
DATA " 42bsf    ,2"," 43bsf    ,3": '0101010fffffff,0101011fffffff
DATA " 44bsf    ,4"," 45bsf    ,5": '0101100fffffff,0101101fffffff
DATA " 46bsf    ,6"," 47bsf    ,7": '0101110fffffff,0101111fffffff

DATA " 48btfsc  ,0"," 49btfsc  ,1": '0110000fffffff,0110001fffffff
DATA " 50btfsc  ,2"," 51btfsc  ,3": '0110010fffffff,0110011fffffff
DATA " 52btfsc  ,4"," 53btfsc  ,5": '0110100fffffff,0110101fffffff
DATA " 54btfsc  ,6"," 55btfsc  ,7": '0110110fffffff,0110111fffffff

DATA " 56btfss  ,0"," 57btfss  ,1": '0111000fffffff,0111001fffffff
DATA " 58btfss  ,2"," 59btfss  ,3": '0111010fffffff,0111011fffffff
DATA " 60btfss  ,4"," 61btfss  ,5": '0111100fffffff,0111101fffffff
DATA " 62btfss  ,6"," 63btfss  ,7": '0111110fffffff,0111111fffffff
DATA "124addlw    ","114andlw    ": '111110kkkkkkkk,111001kkkkkkkk
DATA " 64call     "," 80goto     ": '100kkkkkkkkkkk,101kkkkkkkkkkk
DATA "112iorlw    "," 96movlw    ": '111000kkkkkkkk,1100xxkkkkkkkk
DATA "104retlw    ","120sublw    ": '1101xxkkkkkkkk,11110xkkkkkkkk
DATA "116xorlw    ", *:             '111010kkkkkkkk

DATA INDF,TMR0,PCL,STATUS,FSR,PORTA,PORTB,NIL,EEDATA,EEADR,PCLATH,INTCON

setup: CLS : LOCATE 4, 33: PRINT "SETTING UP"
sp$ = "        ": yes$(0) = "NO ": yes$(1) = "YES"
sp2$ = "                                   ": bit$(0) = "0": bit$(1) = "1"
osc$(1) = "LP": osc$(2) = "XT": osc$(3) = "HS": osc$(4) = "RC"
TASM$ = CHR$(40) + CHR$(5) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
readit: READ a$: IF a$ = "*" THEN GOTO endread
g% = VAL(LEFT$(a$, 3)): b$ = UCASE$(MID$(a$, 4))
IF CODE$(g%) = "" THEN CODE$(g%) = b$: : GOTO readit ELSE STOP
endread: FOR a = 0 TO 11: READ reg$(a): NEXT
FOR a = 12 TO 63: reg$(a) = RIGHT$("0" + HEX$(a), 2): NEXT

loadsendcode: OPEN file$ FOR BINARY AS #1: b = LOF(1)
send$ = INPUT$(b, #1): CLOSE 1
IF b = 0 THEN PRINT file$; " FILE NOT FOUND": KILL file$: BEEP: STOP
RETURN

' *****************

setmachinecodevariables: a = 256
ma = VARSEG(ma%(0)): mb = VARPTR(send$): mc = PEEK(mb + 3) * a + PEEK(mb + 2)
IF ma < 0 THEN ma = ma + 65536!
md = INT(ma / 256): mb = ma - (md * 256): POKE mc + 3, mb: POKE mc + 4, md
RETURN

sendcode: CALL ABSOLUTE(SADD(send$)): RETURN: 'accesses sendit machine code

lines: ln = (80 - LEN(s$)) \ 2: LOCATE down, ln: PRINT s$: RETURN

clearit: LINE (6, 6)-(633, 343), 0, BF: RETURN

'******************

'Mnemonic   Description              Equivalent

'ADDCF f,d  Add Carry to File        BTFSC 3,0
'                                    INCF f,d
'ADDDCF f,d Add Digit Carry to File  BTFSC 3,1
'                                    INCF f,d
'B k        Branch                   GOTO k
'BC k       Branch on Carry          BTFSC 3,0
'                                    GOTO k
'BDC k      Branch on Digit Carry    BTFSC 3,1
'                                    GOTO k
'BNC k      Branch on No Carry       BTFSS 3,0
'                                    GOTO k
'BNDC k     Branch on No Digit Carry BTFSS 3,1
'                                    GOTO k
'BZ k       Branch on Zero           BTFSC 3,2
'                                    GOTO k
'MOVFW f    Move File to W           MOVF f,0
'NEGF f,d   Negate File              COMF f,1
'                                    INCF f,d
'SUBCF f,d  Subtract Carry from File BTFSC 3,0
'                                    DECF f,d
'SUBDCF f,d Subtract Digit Carry from File  BTFSC 3,1
'                                           DECF f,d
'TSTF f     Test File                MOVF f,1

'CLRC       Clear Carry              BCF 3,0
'CLRDC      Clear Digit Carry        BCF 3,1
'CLRZ       Clear Zero               BCF 3,2
'SETC       Set Carry                BSF 3,0
'SETDC      Set Digit Carry          BSF 3,1
'SETZ       Set Zero                 BSF 3,2
'SKPC       Skip on Carry            BTFSS 3,0
'SKPDC      Skip on Digit Carry      BTFSS 3,1
'SKPZ       Skip on Zero             BTFSS 3,2

